<?

require_once 'S_config.php';
require_once 'F_utils.php';
require_once 'L_netmail.php';
require_once 'L_echomail.php';
require_once 'L_fidonet.php';
require_once 'F_archives.php';
require_once "C_msgbase.php";
require_once "F_pkt.php";
require_once "A_common.php";

function AreaToCase($area,$type)
{
	if (strcasecmp($type,'lower')==0):
		return strtolower($area);
	elseif (strcasecmp($type,'upper')==0):
		return strtoupper($area);
	else:
		$l = strlen($area);
		$u = 1;
		for ($i=0;$i<$l;$i++):
			if (preg_match('/[a-z0-9]/i',$area{$i})):
				if ($u):
					$area{$i} = strtoupper($area{$i});
					$u = 0;
				else:
					$area{$i} = strtolower($area{$i});
				endif;
			else:
				$u = 1;
			endif;
		endfor;
		return $area;
	endif;
}

function AutoCreateArea($type,$area,$link = false,$descr = false)
{
	GLOBAL $CONFIG;
	if ($link):
		if (!$CONFIG->GetLinkVar($link,'autoareacreate')) { return 0; };
   		$tofile = $CONFIG->GetLinkVar($link,'autoareacreatefile');
		$options = $CONFIG->GetLinkVar($link,'autoareacreatedefaults');
	endif;
	if (!isset($tofile) || !$tofile) $tofile = $CONFIG->GetVar('autoareacreatefile');
	if (!isset($options) || !$options) $options = $CONFIG->GetVar('autoareacreatedefaults');
	if ((!$tofile) || !is_writable($tofile)) return 0;
	$echotag = AreaToCase($area,$CONFIG->GetVar('createareascase'));
	$path = $CONFIG->GetVar('msgbase').'/'.AreaToCase($area,$CONFIG->GetVar('areasfilenamecase'));
	$line = $type.' '.$echotag.' '.$path;
	if ($descr === false) $descr = GetEchoDescrFromEcholist($area);
	if ($descr) { $line.= " -d \"$descr\""; }
	
	foreach($CONFIG->GetArray('creategroupmask') as $grp_mask):
		$arr = split(' ',$grp_mask,2);
		if (sizeof($arr)==2):
			list($grp,$mask) = $arr;
			$grp = trim($grp);
			$mask = trim($mask);
			if (strcmp(substr($mask,0,1),'/')==0):
				$preg = $mask;
				if (strcasecmp(substr($mask,strlen($mask)-1,1),'i')!=0):
				   	$preg.='i';
				endif;
			else:
				$mask = str_replace('/','\\/',str_replace('\\','\\\\',$mask));
				$mask = str_replace('.','\\.',$mask);
				$mask = str_replace('?','.',str_replace('*','.*',$mask));
				$preg = '/^'.$mask.'$/i';
			endif;
			if (preg_match($preg,$echotag)):
				$line.= ' -g '.$grp;
				break;
			endif;
		endif;
	endforeach;

	$line.= ' '.$options;
	if ($link) $line.= ' '.$link;
	if (!AppendLine($tofile,$line)) return 0;
	$translator = new C_configfile_reader();
	$line = $translator->ReadStr($line);
	$translator->Close();
	$CONFIG->Areas->AppendAreaToConf($line);
	foreach($CONFIG->GetArray('autoareacreateflag') as $newareas) AppendLine($newareas,$echotag);
	return 1;
}

function PackToLink($pkt,$addr)
{
	GLOBAL $CONFIG;
	GLOBAL $Outbound;
	tolog('K',"Packing $pkt to $addr");
	$OutMail = $Outbound->GetMailTo($addr);
	foreach($OutMail as $fname):
		if (preg_match('/^[0-9a-z]{8}.(su|mo|tu|we|th|fr|sa)[0-9a-z]$/i',basename($fname))) {$ArchName = $fname;}
	endforeach;
	list($path,$file) = $Outbound->get_link_filename($addr);
	pc_mkdir_parents($path,0777);
	if (!isset($ArchName)) { 
	srand((double)microtime()*1000000);
	$ArchName = $path.'/'.rand(10000000,99999999).'.'.strtolower(substr(date('D'),0,2)).'0';
	$LoName = "$path/$file.flo";
	$loshka = fopen($LoName,'a');
	fwrite($loshka,basename($ArchName)."\n");
	fclose($loshka);
	chmod($LoName,0666);
	}
	AddToArchive($ArchName,$pkt,$CONFIG->Vars['tempoutbound']);
	unlink($pkt);
	tolog('k',"Finished. Deleting $pkt");
}

function ExtractBundles($inbound,$temp)
{
	tolog('b',"Finding bundles in $inbound");
	$in_dir = opendir($inbound);
	while ($fname = readdir($in_dir)):
	tolog('b',"Found file $fname");
		if (preg_match('/^[0-9a-z]{8}\.(su|mo|tu|we|th|fr|sa)[0-9]$/i',$fname))
		{
			tolog('B',"Found bundle $fname");
			foreach(ExtractArchive("$inbound/$fname",$temp) as $item)
			{
			    tolog('B',"Unpacking file $item");
			}
			unlink($inbound.'/'.$fname);
			tolog('D',"Deleting file $fname");
		}
	endwhile;
}

function CheckSecure($packet)
{
	GLOBAL $CONFIG;
	$fz = $packet->pkt_hat->OrigZone;
	$fn = $packet->pkt_hat->OrigNet;
	$ff = $packet->pkt_hat->OrigNode;
	$fp = $packet->pkt_hat->OrigPoint;
	$dz = $packet->pkt_hat->DestZone;
	$dn = $packet->pkt_hat->DestNet;
	$df = $packet->pkt_hat->DestNode;
	$dp = $packet->pkt_hat->DestPoint;
	$fromaddr = $fz.':'.$fn.'/'.$ff.($fp?'.'.$fp:'');
	$toaddr = $dz.':'.$dn.'/'.$df.($dp?'.'.$dp:'');
	if (!in_array($toaddr,$CONFIG->GetArray('address'))) return -2;
	$pwd = $packet->pkt_hat->Password;
	if (!isset($CONFIG->Links->Vals[$fromaddr])) return 0;
	$linkpwd = $CONFIG->GetLinkVar($fromaddr,'password');
	if (strcmp($pwd,'')==0):
		if ($CONFIG->GetLinkVar($fromaddr,'allowemptypktpwd')):
			return 1;
		else:
			return -3;
		endif;
	else:
		if (strcasecmp($linkpwd,$pwd)==0):
			return 1;
		else:
			return -3;
		endif;
	endif;
	return 1;
}

function Toss_Pkt($name)
{
	tolog('T',"Tossing file $name");
	$packet = new FidoPacket;
	if ($packet->Open($name)):
		$sec = CheckSecure($packet);
		if ($sec >= 0):
			$sav = ($sec == 0);
			$from_pkt = JoinFidoAddr(array($packet->pkt_hat->OrigZone,$packet->pkt_hat->OrigNet,$packet->pkt_hat->OrigNode,$packet->pkt_hat->OrigPoint));
			$message = $packet->ReadMessage();
			while ($message->Version!=0):
				$res = Process_message_Ptosser($message,$from_pkt,$sec==0);
				if (!$res) $sav = 1;
				$message = $packet->ReadMessage();
			endwhile;
			$packet->Close();
			if ($sav):
				tolog('T','Problems during tossing');
				rename($name,$name.'.sav');
			else:
				tolog('t','Tossing finished');
				unlink($name);
			endif;
		else:
			switch($sec):
				case(-1):
					tolog('T',"Error tossing: Security violation");
					rename($name,$name.'.sec');
					break;
				case(-2):
					tolog('T',"Error tossing: Not for us");
					rename($name,$name.'.ntu');
					break;
				case(-3):
					tolog('T',"Error tossing: Password error");
					rename($name,$name.'.sec');
					break;
			endswitch;
		endif;
	else:
		tolog('T','Error during opening packet');
		rename($name,$name.'.err');
	endif;
}

function Begin_Pack()
{
	GLOBAL $OutPkts;
	GLOBAL $OutPktNames;
	GLOBAL $Packing;
	if (!isset($Packing) && !$Packing):
		$OutPkts = array();
		$OutPktNames = array();
		$Packing = true;
		return true;
	else:
		return false;
	endif;
}

function PackMessageTo($message,$packto)
{
	GLOBAL $CONFIG;
	GLOBAL $OutPkts;
	GLOBAL $OutPktNames;
	if (!isset($OutPkts[$packto])):
		srand((double)microtime()*1000000);
		$pktname = $CONFIG->Vars['tempoutbound'].'/'.rand(10000000,99999999).'.pkt';
		$OutPktNames[$packto] = $pktname;
		$OutPkts[$packto] = new FidoPacket;
		$pwd = $CONFIG->GetLinkVar($packto,'password');
		$OutPkts[$packto]->NewPacket($pktname,$CONFIG->GetVar('address'),$packto,$pwd);
	endif;
	tolog('k',"Packing message for $packto");
	$OutPkts[$packto]->message = $message;
	$OutPkts[$packto]->AppendMessage();
}

function End_Pack()
{
	GLOBAL $OutPkts;
	GLOBAL $OutPktNames;
	GLOBAL $Packing;
	if ($Packing):
		$Packing = false;
		if ($OutPkts):
			$links = array_keys($OutPkts);
			foreach($links as $addr):
				$OutPkts[$addr]->FinishPacket();
				PackToLink($OutPktNames[$addr],$addr);
			endforeach;
		endif;
	endif;
}

function Process_message_Ptosser($message,$addr,$onlynetmail)
{
	GLOBAL $CONFIG;
	if (strcasecmp(substr($message->MsgText,0,5),'area:')==0):
		$p = strpos($message->MsgText,"\r");
		$area = trim(substr($message->MsgText,5,$p-5));
		$message->MsgText = substr($message->MsgText,$p+1);
		if ($onlynetmail):
			return 0;
		else:
			$res = Process_echomail_message($message,$addr,$area);
			return $res;
		endif;
	else:
		$res = Process_netmail_message($message,$addr);
		return $res;
	endif;
}

function Run_tosser()
{
	GLOBAL $CONFIG;
	$tempin = $CONFIG->Vars['tempinbound'];
	$inbound = $CONFIG->Vars['inbound'];
	Begin_Pack();
	ExtractBundles($inbound,$tempin);
	$dir = opendir($inbound);
	while ($fname = readdir($dir))
	{ 
		if (preg_match('/\.pkt$/i',$fname)):
		Toss_Pkt("$inbound/$fname"); 
		endif;
	}
	closedir($dir);
	$dir = opendir($tempin);
	while ($fname = readdir($dir))
	{ 
		if (preg_match('/\.pkt$/i',$fname)):
		Toss_Pkt("$tempin/$fname"); 
		endif;
	}
	closedir($dir);
	End_Pack();
}

function ScanArea($area,$netarea)
{
	tolog('S',"Scanning area $area");
	$pk = Begin_Pack();
	$Area = new C_msgbase;
	if ($Area->Open($area)):
		$ms = $Area->GetNumMsgs();
		for ($i=1;$i<=$ms;$i++):
			$header = $Area->ReadMsgHeader($i);
			$attr = $header->Attrs;
			if (($attr & MSG_LOC)&& !($attr & MSG_SNT)):
				if ($netarea):
					ScanNetMessage($area,$i,$Area,$header);
				else:
					ScanMessage($area,$i,$Area,$header);
				endif;
				$Area->SetAttr($i,$attr | MSG_SNT | MSG_SCN);
			endif;
		endfor;
	endif;
	if ($pk) End_Pack();
}

function ScanAllAreas()
{
	GLOBAL $CONFIG;
	Begin_Pack();
	foreach ($CONFIG->Areas->Vals as $area):
		ScanArea($area->EchoTag,strcmp($area->Status,'netmailarea')==0);
	endforeach;
	End_Pack();
}

function ScanListedAreas($file)
{
	GLOBAL $CONFIG;
	Begin_Pack();
	if ($f = fopen($file,'r')):
		while($line = fgets($f,1024)):
			$area = trim($line);
			if ($area):
				if (($areanum = $CONFIG->Areas->FindAreaNum($area))==-1):
					tolog('T',"Area $area not found");
				else:
					ScanArea($area,strcmp($CONFIG->Areas->Vals[$i]->Status,'netmailarea')==0);
				endif;
			endif;
		endwhile;
		fclose($f);
	endif;
	End_Pack();
}

?>
